
function getSubscriptions() {
    return new Promise(function(resolve, reject) {
        $.ajax({
            url: "/api/subscription/",
            type: "GET",
            beforeSend: function(xhr) {
                xhr.setRequestHeader("X-CSRFToken", CSRF_MiddlewareToken);
            },
            success: function(response) {
                resolve(response);
            },
            error: function(response) {
                reject(response);
            }
        });
    });
}

function getSubscription(uuid) {
    return new Promise(function(resolve, reject) {
        $.ajax({
            url: `/api/subscription/${uuid}/`,
            type: "GET",
            beforeSend: function(xhr) {
                xhr.setRequestHeader("X-CSRFToken", CSRF_MiddlewareToken);
            },
            success: function(response) {
                resolve(response);
            },
            error: function(response) {
                reject(response);
            }
        });
    });
}

function newSubscription(formData) {
    return new Promise(function(resolve, reject) {
        $.ajax({
            url: "/api/subscription/",
            type: "POST",
            data: formData,
            processData: false,
            contentType: false,
            beforeSend: function(xhr) {
                xhr.setRequestHeader("X-CSRFToken", CSRF_MiddlewareToken);
            },
            success: function(response) {
                resolve(response);
            },
            error: function(response) {
                reject(response);
            }
        });
    });
}

function editSubscription(uuid, formData) {
    return new Promise(function(resolve, reject) {
        $.ajax({
            url: `/api/subscription/${uuid}/`,
            type: "PUT",
            data: formData,
            processData: false,
            contentType: false,
            beforeSend: function(xhr) {
                xhr.setRequestHeader("X-CSRFToken", CSRF_MiddlewareToken);
            },
            success: function(response) {
                resolve(response);
            },
            error: function(response) {
                reject(response);
            }
        });
    });
}

function deleteSubscription(uuid) {
    return new Promise(function(resolve, reject) {
        $.ajax({
            url: `/api/subscription/${uuid}/`,
            type: "DELETE",
            beforeSend: function(xhr) {
                xhr.setRequestHeader("X-CSRFToken", CSRF_MiddlewareToken);
            },
            success: function(response) {
                resolve(response);
            },
            error: function(response) {
                reject(response);
            }
        });
    });
}